$(document).ready(async function () {

  $('#tutorial').on('click', function () {
    $(document).ready(async function () {
      const driver = new Driver({
        doneBtnText: 'Sair',
        closeBtnText: 'Fechar',
        nextBtnText: 'Próximo',
        prevBtnText: 'Anterior',
        allowClose: false
      });
      driver.defineSteps([{
        element: '#btnFiltros',
        popover: {
          title: 'Botão Filtros',
          description: 'Clique aqui para abrir os filtros e realizar uma consulta.',
          position: 'right'
        }
      },
      {
        element: '#btnImprimir',
        popover: {
          title: 'Botão Imprimir',
          description: 'Clique aqui para imprimir um relatório.',
          position: 'right'
        }
      },
      {
        element: '#divTabelaVendas',
        popover: {
          title: 'Tabela Receber',
          description: 'Aqui, após clicar em consultar ficam os dados das autorizações de pagamento filtradas.',
          position: 'bottom'
        }
      }
      ]);
      driver.start();
    });
  });

  let colunas = JSON.parse(localStorage.getItem('colunasInvisiveisRelatorios'));

  // aqui so valida se nao existe tem que criar para nao dar erro
  if (colunas == null || colunas.relAP == undefined) {
    localStorage.setItem('colunasInvisiveisRelatorios', JSON.stringify({ ...colunas, relAP: [] }));
    colunas = JSON.parse(localStorage.getItem('colunasInvisiveisRelatorios'));
  }

  // confirma as colunas
  $('#btnConfirmarColunas').on('click', async function () {
    try {
      $.LoadingOverlay('show');

      const novasColunas = retornaNovasColunasInvisiveis();
      localStorage.setItem('colunasInvisiveisRelatorios', JSON.stringify({ ...colunas, relAP: novasColunas }))

      $('#tabelaAP').DataTable().columns().visible(true);
      // $('#tabelaPrecosProduto').DataTable().columns(novasColunas).visible(false);

      $('#tabelaAP').DataTable().columns().every(
        function () {
          if ((novasColunas).indexOf(this.dataSrc()) != -1) {
            this.visible(false);
          }
        })

    } finally {
      $.LoadingOverlay('hide');
      $('#modal-ColunasVisiveis').modal('hide');
    }
  })

  await preencheOrdenacaoTela('RelReceber');

  componenteFiltro('entidade', true);

  $('#btnFiltros').on('click', async function () {
    $('#modal-filtros').modal('show');
  });


  $('#btnLimparFiltros').on('click', async function () {
    $('#txtAPde').val('');
    $('#txtAPate').val('');
    $('#txtClienteConsulta').val('');

    $('#txtVenctoDe').val('1200-01-01');
    $('#txtVenctoAte').val('2500-12-31');
    $('#txtDataEmiDe').val('1200-01-01');
    $('#txtDataEmiAte').val('2500-12-31');
    $('#txtDigitacaoDe').val('1200-01-01');
    $('#txtDigitacaoAte').val('2500-12-31');
    $('#txtNF').val('');
    $('#txtEntidade').empty().trigger('change');
  });

  $('#btnSelecionarEmpresas').on('click', function () {
    carregaEmpresasDisponiveis();
  });

  async function retornaFiltros() {
    const sTipo = $('input[name="rd"]:checked').val()
    const sAPAberto = $('#cbAPAberto').is(':checked') ? 'S' : 'N';
    // const sRatioCP = $('#cbRateioCP').is(':checked') ? 'S' : 'N';
    const sAntecipacao = $('#cbAntecipacao').is(':checked') ? 'S' : 'N';
    const sAPde = $('#txtAPde').val();
    const sAPate = $('#txtAPate').val();
    const sDataVenctoDe = $('#txtVenctoDe').val();
    const sDataVenctoAte = $('#txtVenctoAte').val();
    const sDataEmissaoDe = $('#txtDataEmiDe').val();
    const sDataEmissaoAte = $('#txtDataEmiAte').val();
    const sDataDigiDe = $('#txtDigitacaoDe').val();
    const sDataDigiAte = $('#txtDigitacaoAte').val();
    const sFornecedor = await formataListas($('#txtEntidade').val().toString());
    const sNF = $('#txtNF').val();
    const sEmp = $('.empresa_selecionada:checked').toArray().length > 0 ? $('.empresa_selecionada:checked').toArray().map(input => input.id.substring(input.id.indexOf('-') + 1, input.id.length))
      : getCookie('emp_id');

    
    const retorno = ` TIPO=${sTipo}` +
      `&APABERTO=${sAPAberto}` +
      `&ANTECIPACAO=${sAntecipacao}` + 
      `&APDE=${sAPde}` + 
      `&APATE=${sAPate}` +
      `&DATAVENCTODE=${sDataVenctoDe}` +
      `&DATAVENCTOATE=${sDataVenctoAte}` +
      `&DATAEMISSAODE=${sDataEmissaoDe}` +
      `&DATAEMISSAOATE=${sDataEmissaoAte}` + 
      `&DATADIGIDE=${sDataDigiDe}` + 
      `&DATADIGIATE=${sDataDigiAte}` +
      `&FORNECEDOR=${sFornecedor}` +
      `&NF=${sNF}` +
      `&EMPRESAS_FILTRO=${sEmp}`;
    return retorno;
  }

  $('#btnImprimir').on('click', async function () {
    try {
      $.LoadingOverlay('show');
      try {
        const url = `/sisplan/impressao/v1/imprimerelap?`;
        const filtros = await retornaFiltros();
        const ordem = `&TELA_ORDENACAO=RelAP&ORDEM_ORDENACAO=${$('#txtOrdem').val()}`;
        const bImprimeAutomatico = await verificaImprimirAutomatico('RelAP');
        const arquivo = await GeraRelatorio(`${url}${filtros}${ordem}&`, 'GET', 100000, false, 'RelAP');
        if (arquivo != undefined) {
          if (!bImprimeAutomatico) {
            window.open(`${BASE_URI}/relatorios_api/pdf/${arquivo}`, '_blank');
          }
          await limparRelatorios();
        }

      } catch (error) {
        console.error(error);
      }
    } finally {
      $.LoadingOverlay('hide');
    }
  });

  $('#btnConsultar').on('click', async function () {
    try {
      $.LoadingOverlay('show');
      try {
        let dataSetCols = [];

        const url = '/sisplan/impressao/v1/consultarelap?';
        const filtros = await retornaFiltros();
        const response = await requisicao('GET', url, filtros,
          null
        );

        if (!response) {
          return;
        }

        const jsonStr = await response.json();

        if (jsonStr.length == 0) {
          msgAlerta('Nenhum registro encontrado!');
         
          $(`#tabelaAP`).DataTable().clear().draw(false);
          return;
        }

        if (response.status != 200) {
          console.error(jsonStr.mensagem);
          return;
        }

        let keys = Object.keys(jsonStr[0]);

        keys.forEach(k => {
          dataSetCols.push({
            'title': k,
            'data': k
          });
        });

        $('#tabelaAP').DataTable({
          destroy: true,
          colReorder: true,
          filter: false,
          language: {
            sEmptyTable: 'Nenhum registro encontrado',
            sInfo: '_TOTAL_ registros',
            sInfoEmpty: ' 0 registros',
            sInfoFiltered: '(Filtrados de _MAX_ registros)',
            sInfoPostFix: '',
            sInfoThousands: '.',
            sLengthMenu: '_MENU_ resultados',
            sLoadingRecords: 'Carregando...',
            sProcessing: 'Processando...',
            sZeroRecords: 'Nenhum registro encontrado',
            sSearch: 'Pesquisar',
            oPaginate: {
              sNext: 'Próximo',
              sPrevious: 'Anterior',
              sFirst: 'Primeiro',
              sLast: 'Último',
            },
            oAria: {
              sSortAscending: ': Ordenar colunas de forma ascendente',
              sSortDescending: ': Ordenar colunas de forma descendente',
            },
          },
          autoWidth: true,
          "data": jsonStr,
          "columns": dataSetCols,
          columnDefs: [{
            "render": function (data) {
              return parseFloat(data).toLocaleString('pt-BR', {
                maximumFractionDigits: 2,
                minimumFractionDigits: 2
              });
            },
            "targets": [19, 20, 23, 24, 25, 38, 39, 45, 46]
          },
          {
            "render":function (data, type, row) {
                // alert(navigator['userAgent'])
                let isIE = function () {
                    if (/MSIE/i.test(navigator.userAgent) == true || /Edge/i.test(navigator.userAgent) == true) {
                        return true;
                    }
                    return false;

                };
                if (isIE()) {
                    x = data.slice(0, 10).split('-');
                    return `${x[2]}/${x[1]}/${x[0]}`;
                }
                x = data.slice(0, 10).split('-');
                return `${x[2]}/${x[1]}/${x[0]}`;

            },
            "targets": [2, 3, 4, 5]
        },
        
        ],
          
        });

        const colunasInvisiveis = JSON.parse(localStorage.getItem('colunasInvisiveisRelatorios'));

        $('#tabelaAP_length').prepend('<button class="buttonColVis" id="buttonColVis"><i class="fas fa-cogs"></i></button>');
        $('#tabelaAP_length').prepend('<button class="buttonExcel" id="buttonExcel"><i class="fas fa-file-excel"></i></button>');

        $('#buttonColVis').prop('title', 'Configurar colunas visíveis')
        $('#buttonExcel').prop('title', 'Exportar')

        $('#buttonColVis').on('click', async function () {
          $.LoadingOverlay('show');
          $('#modal-ColunasVisiveis').modal('show');
          $.LoadingOverlay('hide');
        });

        $('#buttonExcel').on('click', async function () {
          const url = '/sisplan/impressao/v1/consultarelap?';
          const filtros = await retornaFiltros();
          await exportaCSV(url, filtros, false, null, 'Relatório de Autorização de Pagamento', '#tabelaAP');
        })


        $('#tabelaAP').DataTable().columns().every(
          function () {
            if ((colunasInvisiveis.relAP).indexOf(this.dataSrc()) != -1) {
              this.visible(false);
            }
          })

      } catch (error) {
        console.error(error);
      }
    } finally {
      $.LoadingOverlay('hide');
      $('#modal-filtros').modal('hide');
    }
  });

  $('#modal-ColunasVisiveis').on('show.bs.modal', function () {
    const cols = [];

    let colunasInvisiveis = JSON.parse(localStorage.getItem('colunasInvisiveisRelatorios'))

    $('#tabelaAP').DataTable().columns().every(function () {
      cols.push({
        'title': $(this.header()).text(),
        'data': this.dataSrc()
      })
    });

    adicionaColunas(cols, colunasInvisiveis.relAP ?? [])
  });
});